/***************************************************************************
                          kconfigdlg.cpp  -  description
                             -------------------
    begin                : Sun May 21 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kpgpcrypt.h"
#include "kconfigdlg.h"
#include "qconfig.h"
#include <stdlib.h>

extern KPGPCrypt *Ventana;

KConfigDlg::KConfigDlg(QWidget *parent, const char *name) : QDialog(parent,name,true)
{
	initDialog();
	connect(m_Guardar,SIGNAL(released()),this,SLOT(slotGuardar()));	
	connect(m_Salir,SIGNAL(released()),this,SLOT(slotSalir()));		
	m_pgpe->setText(Ventana->pgpe);
	m_pgps->setText(Ventana->pgps);
	m_pgpk->setText(Ventana->pgpk);
	m_pgpv->setText(Ventana->pgpv);			
	m_pgp6->setText(Ventana->pgp60);
	m_gpg->setText(Ventana->gpg);
}

KConfigDlg::~KConfigDlg()
{
}
/**  */
void KConfigDlg::slotGuardar()
{
	char		buffer[256];

	strcpy(buffer,(const char *)getenv("HOME"));
  strcat(buffer,"/.kde/share/apps/kpgpcrypt/kpgpcrypt.rc");
	
	QConfig archivoConfig(buffer);
	archivoConfig.setGroup("Ejecutables");
	(Ventana->pgpe)  = m_pgpe->text();
	archivoConfig.escribirEntrada("PGP500_Encriptado",Ventana->pgpe);
	(Ventana->pgps)  = m_pgps->text();
	archivoConfig.escribirEntrada("PGP500_Firmado",Ventana->pgps);	
	(Ventana->pgpk)  = m_pgpk->text();
	archivoConfig.escribirEntrada("PGP500_Llaves",Ventana->pgpk);	
	(Ventana->pgpv)  = m_pgpv->text();	
	archivoConfig.escribirEntrada("PGP500_Verificacion",Ventana->pgpv);	
	(Ventana->pgp60) = m_pgp6->text();
	archivoConfig.escribirEntrada("PGP651",Ventana->pgp60);	
	(Ventana->gpg)   = m_gpg->text();
	archivoConfig.escribirEntrada("GNUPG 1.00",Ventana->gpg);
	hide();
	
   printf("Mensaje %s\n",&(Ventana->pgp60));
}
/**  */
void KConfigDlg::slotSalir()
{
	hide();
}
