/***************************************************************************
                          kparametros.cpp  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Christian Rossi
    email                : crossi@mailcity.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kparametros.h"
#include "kcambiarparam.h"
#include "kpgpcrypt.h"
#include <stdlib.h>

extern KPGPCrypt *Ventana;


KParametros::KParametros(QWidget *parent, const char *name) : QWidget(parent,name)
{
	initDialog();
	connect(Lista, SIGNAL(doubleClicked(QListViewItem *)),this,SLOT(doubleClicked(QListViewItem *)) );
	
	if (operator==(Ventana->Version(),"PGP 5.00"))
		LeerConfig500();
	else if (operator==(Ventana->Version(),"PGP 6.51"))
		LeerConfig651();
	else if (operator==(Ventana->Version(),"GNUPG 1.00"))
		cantidadParametros=0;

	mostrarParametros();
}

KParametros::~KParametros(){
}

/**  */
void KParametros::resizeEvent ( QResizeEvent * e)
{
	QSize				medida;	

	QWidget::resizeEvent(e);
	medida = e->size();
	Lista->resize(medida.width(),medida.height());
}

/**  */
void KParametros::doubleClicked(QListViewItem *ItemElegido)
{
	int						i;
	QString 			Texto;
	
			
	// Aca debo preguntar por la contidad de parametros de configuracion de
	// la version del PGP
	
	// Busco cual es el parametro a modificar		
	for (i=0;i<cantidadParametros;i++)
	{
		if (!strcmp(Item[i]->text(0),ItemElegido->text(0)))
			break;
	}
		
	Texto = ItemElegido->text(1);

	KCambiarParam	cambiarParam(&Texto);	
	cambiarParam.exec();
		
	Item[i]->setText(1,Texto);
	
	QString base = getenv("HOME");
	QString path = base + "/.kpgpcrypt/icons/cambio-config.xpm";
	QPixmap *pixmap = new QPixmap(path);
	Item[i]->setPixmap(0,*pixmap);
	delete pixmap;
	Lista->repaint();
}

/**  */
void KParametros::mostrarParametros()
{
	int			i;
	QPixmap *pixmap;
		
	// Aca debo preguntar por la contidad de parametros de configuracion de
	// la version del PGP

	QString base = getenv("HOME");	
	QString path = base + "/.kpgpcrypt/icons/config.xpm";	
	pixmap = new QPixmap(path);

	for(i=0;i<cantidadParametros;i++)
	{
	 	Lista->insertItem(Item[i]);
		Item[i]->setPixmap(0,*pixmap);
	}
	delete pixmap;
}

/****************************************
 * Lee el archivo de configuracion para *
 * la version de PGP 5.x                *
 ****************************************/
void KParametros::LeerConfig500()
{
	char	buffer[401];
	char	Auxiliar[100];
	FILE	*stream;

	strcpy(buffer,getenv("HOME"));
	strcat(buffer,"/.pgp/pgp.cfg");
	stream = fopen(buffer,"r");

	
	// Le coloco los valores default
	Item[0]  = new QListViewItem(Lista,"Language","us");
	Item[1]  = new QListViewItem(Lista,"HTTPKeyServerHost","pgpkeys.mit.edu");
	QString base = getenv("HOME");
	base.operator+=("/.pgp/Language50.txt");
	Item[2]  = new QListViewItem(Lista,"LanguageFile",base);
	base = getenv("HOME");
	base.operator+=("/.pgp/pubring.pkr");
	Item[3]  = new QListViewItem(Lista,"PubRing",base);
	base = getenv("HOME");
	base.operator+=("/.pgp/pubring.pkr");
	Item[4]  = new QListViewItem(Lista,"SecRing",base);
	Item[5]  = new QListViewItem(Lista,"RandomDevice","/dev/random");
	Item[6]  = new QListViewItem(Lista,"ArmorLines","off");
	Item[7]  = new QListViewItem(Lista,"HTTPKeyServerPort","11371");
	Item[8]  = new QListViewItem(Lista,"Armor","off");
	Item[9]  = new QListViewItem(Lista,"AutoServerFetch","on");
	Item[10] = new QListViewItem(Lista,"Compress","on");
	Item[11] = new QListViewItem(Lista,"EncryptToSelf","off");
	Item[12] = new QListViewItem(Lista,"FastKeyGen","on");
	Item[13] = new QListViewItem(Lista,"NoBatchInvalidKeys","on");
	
	// Levanto del archivo los valores reales
	if (stream)
	{
		fgets(buffer,400,stream);
		while(!feof(stream))
		{

			// En Auxiliar queda el parametro y en buffer	el valor de parametro
			strcpy(Auxiliar,strtok(buffer,"="));
			strcpy(buffer,strtok(NULL,""));	
  		// Elimino el NEWLINE CHARACTER
			char * aaa = strchr(buffer,'\n');	
			strcpy(aaa,"\0");
	
			/******************************************
			 * Empiezo a preguntar por cada parametro *
			 ******************************************/
					
			// Llave Default del PGP						
			if (!strncmp(Auxiliar,"MyName",6))
			{
			}
				
			// Idioma del PGP
			if (!strcmp(Auxiliar,"Language"))
				Item[0]->setText(1,buffer);

			// Nombre de servidor de llaves
			if (!strncmp(Auxiliar,"HTTPKeyServerHost",17))
				Item[1]->setText(1,buffer);

			// Archivo de Idioma
			if (!strncmp(Auxiliar,"LanguageFile",12))
				Item[2]->setText(1,buffer);
				
			// Anillo Publico
			if (!strncmp(Auxiliar,"PubRing",7))
				Item[3]->setText(1,buffer);
				
			// Anillo Secreto
			if (!strncmp(Auxiliar,"SecRing",7))
				Item[4]->setText(1,buffer);
				
			// Dispositivo Aleatorio
			if (!strncmp(Auxiliar,"RandomDevice",12))
				Item[5]->setText(1,buffer);
				
			// Armor Lines del PGP
			if (!strncmp(Auxiliar,"ArmorLines",10))
				Item[6]->setText(1,buffer);

      // Puerto del servidor de llaves								
			if (!strncmp(Auxiliar,"HTTPKeyServerPort",17))
				Item[7]->setText(1,buffer);
				
			// Armor del PGP
			if (!strncmp(Auxiliar,"Armor",5))
				Item[8]->setText(1,buffer);

 			// Auto Server Fetch
			if (!strncmp(Auxiliar,"AutoServerFetch",15))
				Item[9]->setText(1,buffer);
				
 			// Compress
			if (!strncmp(Auxiliar,"Compress",8))
				Item[10]->setText(1,buffer);

 			// Encrypt To Self
			if (!strncmp(Auxiliar,"EncryptToSelf",13))
				Item[11]->setText(1,buffer);

 			// Fast Key Generation
			if (!strncmp(Auxiliar,"FastKeyGen",10))
				Item[12]->setText(1,buffer);

 			// No Batch Invalid Keys
			if (!strncmp(Auxiliar,"NoBatchInvalidKeys",18))
				Item[13]->setText(1,buffer);

			fgets(buffer,400,stream);
		}
		fclose(stream);
		cantidadParametros = 14;
	}
	else
		cantidadParametros = 14;
}
/**  */
void KParametros::GuardarConfigPGP()
{
	int		CantidadParametros = 9;	
	int		i;
	
	char	buffer[401];
	FILE	*stream;

	strcpy(buffer,getenv("HOME"));
	strcat(buffer,"/.pgp/pgp.cfg");
	stream = fopen(buffer,"w");

	QString base = getenv("HOME");
	QString path = base + "/.kpgpcrypt/icons/config.xpm";	
	QPixmap *	pixmap = new QPixmap(path);
		
	for (i = 0;i<CantidadParametros;i++)
	{
		strcpy(buffer,Item[i]->text(0));
		strcat(buffer,"=");
		strcat(buffer,Item[i]->text(1));
		strcat(buffer,"\n");
		fputs(buffer,stream);
		Item[i]->setPixmap(0,*pixmap);
	}
	fclose(stream);	
	
	delete pixmap;
	
}
/**  */
void KParametros::LeerConfig651()
{
	char	buffer[401];
	char	Auxiliar[100];
	FILE	*stream;

	strcpy(buffer,getenv("HOME"));
	strcat(buffer,"/.pgp/pgp.cfg");
	stream = fopen(buffer,"r");

	// Le coloco los valores default
	Item[0]  = new QListViewItem(Lista,"Language","us");
	QString base = getenv("HOME");
	base.operator+=("/.pgp/pubring.pkr");
	Item[1]  = new QListViewItem(Lista,"PubRing",base);
	base = getenv("HOME");
	base.operator+=("/.pgp/secring.skr");
	Item[2]  = new QListViewItem(Lista,"SecRing",base);
	Item[3]  = new QListViewItem(Lista,"RandomDevice","/dev/random");
	Item[4]  = new QListViewItem(Lista,"ArmorLines","off");
	Item[5]  = new QListViewItem(Lista,"Armor","off");
	Item[6] = new QListViewItem(Lista,"Compress","on");
	Item[7] = new QListViewItem(Lista,"EncryptToSelf","off");
	Item[8] = new QListViewItem(Lista,"FastKeyGen","on");

	
	// Levanto del archivo los valores reales
	if (stream)
	{
		fgets(buffer,400,stream);
		while(!feof(stream))
		{

			// En Auxiliar queda el parametro y en buffer	el valor de parametro
			strcpy(Auxiliar,strtok(buffer,"="));
			strcpy(buffer,strtok(NULL,""));	
  		// Elimino el NEWLINE CHARACTER
			char * aaa = strchr(buffer,'\n');	
			strcpy(aaa,"\0");
	
			/******************************************
			 * Empiezo a preguntar por cada parametro *
			 ******************************************/
					
			// Llave Default del PGP						
			if (!strncmp(Auxiliar,"MyName",6))
			{
			}
				
			// Idioma del PGP
			if (!strcmp(Auxiliar,"Language"))
				Item[0]->setText(1,buffer);

			// Anillo Publico
			if (!strncmp(Auxiliar,"PubRing",7))
				Item[1]->setText(1,buffer);
				
			// Anillo Secreto
			if (!strncmp(Auxiliar,"SecRing",7))
				Item[2]->setText(1,buffer);
				
			// Dispositivo Aleatorio
			if (!strncmp(Auxiliar,"RandomDevice",12))
				Item[3]->setText(1,buffer);
				
			// Armor Lines del PGP
			if (!strncmp(Auxiliar,"ArmorLines",10))
				Item[4]->setText(1,buffer);

			// Armor del PGP
			if (!strncmp(Auxiliar,"Armor",5))
				Item[5]->setText(1,buffer);

 			// Compress
			if (!strncmp(Auxiliar,"Compress",8))
				Item[6]->setText(1,buffer);

 			// Encrypt To Self
			if (!strncmp(Auxiliar,"EncryptToSelf",13))
				Item[7]->setText(1,buffer);

 			// Fast Key Generation
			if (!strncmp(Auxiliar,"FastKeyGen",10))
				Item[8]->setText(1,buffer);
			
			fgets(buffer,400,stream);
		}
		fclose(stream);
		cantidadParametros = 9;
	}
	else
		cantidadParametros = 9;
}
/**  */
void KParametros::borrarParametros()
{
	for (int i=0;i<cantidadParametros;i++)
	{
		delete Item[i];
	}
	Lista->clear();
}
